| Linduino 1.3.0 Linear Technology Arduino-Compatible Demonstration Board

Functions | Macros | Enumerations | Variables
DC1534A.ino File Reference
Digital-to-Analog Converters (DAC) » LTC2637: Octal 12-/10-/8-Bit I2C VOUT DACs with 10ppm/°C Reference

Linear Technology DC1534A Demonstration Board. More...

## Detailed Description

Linear Technology DC1534A Demonstration Board.

LTC2637: Octal 12-/10-/8-Bit I2C VOUT DACs with 10ppm/°C Reference.

Linear Technology DC1593A Demonstration Board. LTC2635: Quad 12-/10-/8-Bit I2C VOUT DACs with 10ppm/°C Reference

    NOTES
     Setup:
       Set the terminal baud rate to 115200 and select the newline terminator.
       The program displays calculated voltages which are based on the voltage
       of the reference used, be it internal or external. A precision voltmeter
       is needed to verify the actual measured voltages against the calculated
       voltage displayed. If an external reference is used, a precision voltage
       source is required to apply the external reference voltage. A
       precision voltmeter is also required to measure the external reference
       voltage. No external power supply is required. Any assembly option may
       be used: DC1534A-A, DC1534A-B, DC1534A-C, DC1534A-D.

     Explanation of Commands:
       1- Select DAC: Select one of eight DACs to test : A, B, C, D, E, F, G, H.

       2- Write to DAC input register: Value is stored in the DAC for updating
          later, allowing multiple channels to be updated at once, either
          through a software "Update All" command or by asserting the LDAC# pin.
          User will be prompted to enter either a code in hex or decimal, or a
          voltage. If a voltage is entered, a code will be calculated based on
          the active scaling and reference parameters - ideal values if no
          calibration was ever stored.

       3- Write and Update: Similar to item 1, but DAC is updated immediately.

       4- Update DAC: Copies the value from the input register into the DAC
          Register. Note that a "write and update" command writes the code to
          BOTH the input register and DAC register, so subsequent "update"
          commands will simply re-copy the same data (no change in output.)

       5- Power Down DAC: Disable DAC output. Power supply current is reduced.
          DAC code present in DAC registers at time of shutdown are preserved.

       6- Set reference mode, either internal or external: Selecting external
          mode prompts for the external reference voltage, which is used directly
          if no individual DAC calibration is stored. The selection and entered
          voltage are stored to EEPROM so it is persistent across reset / power cycles.

       7- Calibrate DAC: Use a precision voltmeter to obtain and enter VOUT
          readings taken with different DAC codes. Set reference mode FIRST,
          as values are stored separately for internal and external reference
          mode. Entries are used to calculate the closest code to send to the
          DAC to achieve an entered voltage.

       8- Enable / Disable calibration: Switch between stored calibration
          values and defaults. Calibration parameters are stored separately
          for internal and external reference modes. Ideal calibration will
          be used if the calibration parameter valid key is not set.

    USER INPUT DATA FORMAT:
     decimal : 1024
     hex     : 0x400
     octal   : 02000  (leading 0 "zero")
     binary  : B10000000000
     float   : 1024.0

http://www.linear.com/product/LTC2637 http://www.linear.com/product/LTC2635

http://www.linear.com/product/LTC2637#demoboards http://www.linear.com/product/LTC2635#demoboards

Copyright 2018(c) Analog Devices, Inc.

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
- Neither the name of Analog Devices, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
- The use of this software may or may not infringe the patent rights of one or more patent holders. This license does not release you from the requirement that you obtain separate licenses from these patent holders to use this software.
- Use of the software either in source or binary form, must be run on or directly connected to an Analog Devices Inc. component.

THIS SOFTWARE IS PROVIDED BY ANALOG DEVICES "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL ANALOG DEVICES BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, INTELLECTUAL PROPERTY RIGHTS, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Definition in file DC1534A.ino.

Go to the source code of this file.

## Functions
static int8_t | restore_calibration ()
| Read stored calibration parameters from nonvolatile EEPROM on demo board. More...
static void | print_title ()
| Prints the title block when program first starts. More...
static void | print_prompt (int16_t selected_dac)
| Prints main menu. More...
static int16_t | prompt_voltage_or_code ()
| Prompt user to enter a voltage or digital code to send to DAC. More...
static uint16_t | get_voltage (float LTC2637_lsb, int16_t LTC2637_offset)
| Get voltage from user input, calculate DAC code based on lsb, offset. More...
static uint16_t | get_code ()
| Get code to send to DAC directly, in decimal, hex, or binary. More...
static int8_t | calibrate_dac (uint8_t index)
| Calibrate the selected DAC using a voltmeter. More...
static int8_t | menu_1_select_dac (int16_t *selected_dac)
| Select which DAC to operate on. More...
static int8_t | menu_2_write_to_input_register (int16_t selected_dac)
| Write data to input register, but do not update DAC output. More...
static int8_t | menu_3_write_and_update_dac (int16_t selected_dac)
| Write data to DAC register (which updates output immediately) More...
static int8_t | menu_4_update_power_up_dac (int16_t selected_dac)
| Update DAC with data that is stored in input register, power up if sleeping. More...
static int8_t | menu_5_power_down_dac (int16_t selected_dac)
| Power down DAC. More...
static int8_t | menu_6_set_reference_mode (void)
| Set reference mode and store to EEPROM. More...
static int8_t | menu_7_calibrate_dacs ()
| Calibrate all DACs by measuring two known outputs. More...
static void | setup ()
| Initialize Linduino. More...
static void | loop ()
| Repeats Linduino loop. More...

## Macros
#define | EEPROM_CAL_KEY_INT 0x5678
| Calibration associated with internal reference. More...
#define | EEPROM_CAL_KEY_EXT 0x9ABC
| Calibration associated with external reference. More...
#define | REF_INTERNAL LTC2637_CMD_INTERNAL_REFERENCE
| Stored reference state is Internal. More...
#define | REF_EXTERNAL LTC2637_CMD_EXTERNAL_REFERENCE
| Stored reference state is External. More...
#define | STORED_REF_STATE_BASE EEPROM_CAL_STATUS_ADDRESS
| Base address of the stored reference state. More...
#define | INT_CAL_VALID_BASE STORED_REF_STATE_BASE + 2
| Base address of the "internal ref calibration valid" flag. More...
#define | INT_CAL_PARAMS_BASE INT_CAL_VALID_BASE + 2
| Base address of the internal ref calibration parameters. More...
#define | EXT_CAL_VALID_BASE INT_CAL_PARAMS_BASE + 32
| Base address of the "external ref calibration valid" flag. More...
#define | EXT_CAL_PARAMS_BASE EXT_CAL_VALID_BASE + 2
| Base address of the external ref calibration parameters. More...
#define | EXT_REF_V_BASE EXT_CAL_PARAMS_BASE + 32
| Base address of the stored external reference voltage. More...

## Enumerations
enum | { PROMPT_VOLTAGE = 0, PROMPT_CODE = 1 }
| Used to keep track to print voltage or print code. More...

## Variables
static uint8_t | demo_board_connected
| Set to 1 if the board is connected. More...
static uint8_t | shift_count
| The data align shift count. More...
static uint8_t | reference_mode
| Tells whether to set internal or external reference. More...
static float | reference_voltage
| Reference voltage, either internal or external. More...
static int16_t | LTC2637_offset [9]
| DAC offset - index 8 for "all DACs". More...
static float | LTC2637_lsb [9]
| The LTC2637 lsb - index 8 for "all DACs". More...
static uint8_t | num_of_channels = 8
const uint8_t | address_map [9] = {LTC2637_DAC_A, LTC2637_DAC_B, LTC2637_DAC_C, LTC2637_DAC_D, LTC2637_DAC_E, LTC2637_DAC_F, LTC2637_DAC_G, LTC2637_DAC_H, LTC2637_DAC_ALL}
| Lookup table for DAC address. More...

## Function Documentation

## ◆ calibrate_dac()

static int8_t calibrate_dac | ( | uint8_t | index | ) |
| static

Calibrate the selected DAC using a voltmeter.

The routine does a linear curve fit given two data points.

Returns
  ACK bit (0=acknowledge, 1=no acknowledge)

Definition at line 551 of file DC1534A.ino.

## ◆ get_code()

static uint16_t get_code | ( |  | ) |
| static

Get code to send to DAC directly, in decimal, hex, or binary.

Returns
  Returns DAC code from user

Definition at line 490 of file DC1534A.ino.

## ◆ get_voltage()

static uint16_t get_voltage | ( | float | LTC2637_lsb,
|  | int16_t | LTC2637_offset
| ) |  |
| static

Get voltage from user input, calculate DAC code based on lsb, offset.

Returns
  Returns DAC voltage

Definition at line 476 of file DC1534A.ino.

## ◆ loop()

static void loop | ( | void |  | ) |
| static

Repeats Linduino loop.

Definition at line 202 of file DC1534A.ino.

## ◆ menu_1_select_dac()

static int8_t menu_1_select_dac | ( | int16_t * | selected_dac | ) |
| static

Select which DAC to operate on.

Returns
  0

Definition at line 255 of file DC1534A.ino.

## ◆ menu_2_write_to_input_register()

static int8_t menu_2_write_to_input_register | ( | int16_t | selected_dac | ) |
| static

Write data to input register, but do not update DAC output.

Returns
  ACK bit (0=acknowledge, 1=no acknowledge)

Definition at line 269 of file DC1534A.ino.

## ◆ menu_3_write_and_update_dac()

static int8_t menu_3_write_and_update_dac | ( | int16_t | selected_dac | ) |
| static

Write data to DAC register (which updates output immediately)

Returns
  ACK bit (0=acknowledge, 1=no acknowledge)

Definition at line 285 of file DC1534A.ino.

## ◆ menu_4_update_power_up_dac()

static int8_t menu_4_update_power_up_dac | ( | int16_t | selected_dac | ) |
| static

Update DAC with data that is stored in input register, power up if sleeping.

Returns
  ACK bit (0=acknowledge, 1=no acknowledge)

Definition at line 301 of file DC1534A.ino.

## ◆ menu_5_power_down_dac()

static int8_t menu_5_power_down_dac | ( | int16_t | selected_dac | ) |
| static

Power down DAC.

Returns
  ACK bit (0=acknowledge, 1=no acknowledge)

Definition at line 317 of file DC1534A.ino.

## ◆ menu_6_set_reference_mode()

static int8_t menu_6_set_reference_mode | ( | void |  | ) |
| static

Set reference mode and store to EEPROM.

Returns
  0

Definition at line 333 of file DC1534A.ino.

## ◆ menu_7_calibrate_dacs()

static int8_t menu_7_calibrate_dacs | ( |  | ) |
| static

Calibrate all DACs by measuring two known outputs.

Returns
  0

Definition at line 353 of file DC1534A.ino.

## ◆ print_prompt()

static void print_prompt | ( | int16_t | selected_dac | ) |
| static

Prints main menu.

Definition at line 518 of file DC1534A.ino.

## ◆ print_title()

static void print_title | ( | void |  | ) |
| static

Prints the title block when program first starts.

Definition at line 503 of file DC1534A.ino.

## ◆ prompt_voltage_or_code()

static int16_t prompt_voltage_or_code | ( |  | ) |
| static

Prompt user to enter a voltage or digital code to send to DAC.

Returns
  prompt type

Definition at line 460 of file DC1534A.ino.

## ◆ restore_calibration()

static int8_t restore_calibration | ( |  | ) |
| static

Read stored calibration parameters from nonvolatile EEPROM on demo board.

Returns
  Return 1 if successful, 0 if not

Definition at line 367 of file DC1534A.ino.

## ◆ setup()

static void setup | ( | void |  | ) |
| static

Initialize Linduino.

Definition at line 184 of file DC1534A.ino.

## Macro Definition Documentation

## ◆ EEPROM_CAL_KEY_EXT

#define EEPROM_CAL_KEY_EXT 0x9ABC

Calibration associated with external reference.

Definition at line 126 of file DC1534A.ino.

## ◆ EEPROM_CAL_KEY_INT

#define EEPROM_CAL_KEY_INT 0x5678

Calibration associated with internal reference.

Definition at line 125 of file DC1534A.ino.

## ◆ EXT_CAL_PARAMS_BASE

#define EXT_CAL_PARAMS_BASE EXT_CAL_VALID_BASE + 2

Base address of the external ref calibration parameters.

Definition at line 139 of file DC1534A.ino.

## ◆ EXT_CAL_VALID_BASE

#define EXT_CAL_VALID_BASE INT_CAL_PARAMS_BASE + 32

Base address of the "external ref calibration valid" flag.

Definition at line 138 of file DC1534A.ino.

## ◆ EXT_REF_V_BASE

#define EXT_REF_V_BASE EXT_CAL_PARAMS_BASE + 32

Base address of the stored external reference voltage.

Definition at line 140 of file DC1534A.ino.

## ◆ INT_CAL_PARAMS_BASE

#define INT_CAL_PARAMS_BASE INT_CAL_VALID_BASE + 2

Base address of the internal ref calibration parameters.

Definition at line 137 of file DC1534A.ino.

## ◆ INT_CAL_VALID_BASE

#define INT_CAL_VALID_BASE STORED_REF_STATE_BASE + 2

Base address of the "internal ref calibration valid" flag.

Definition at line 136 of file DC1534A.ino.

## ◆ REF_EXTERNAL

#define REF_EXTERNAL LTC2637_CMD_EXTERNAL_REFERENCE

Stored reference state is External.

Definition at line 132 of file DC1534A.ino.

## ◆ REF_INTERNAL

#define REF_INTERNAL LTC2637_CMD_INTERNAL_REFERENCE

Stored reference state is Internal.

Definition at line 131 of file DC1534A.ino.

## ◆ STORED_REF_STATE_BASE

#define STORED_REF_STATE_BASE EEPROM_CAL_STATUS_ADDRESS

Base address of the stored reference state.

Definition at line 135 of file DC1534A.ino.

## Enumeration Type Documentation

## ◆ anonymous enum

anonymous enum

Used to keep track to print voltage or print code.

Enumerator
PROMPT_VOLTAGE | 0
PROMPT_CODE | 1

Definition at line 177 of file DC1534A.ino.

## Variable Documentation

## ◆ address_map

const uint8_t address_map[9] = {LTC2637_DAC_A, LTC2637_DAC_B, LTC2637_DAC_C, LTC2637_DAC_D, LTC2637_DAC_E, LTC2637_DAC_F, LTC2637_DAC_G, LTC2637_DAC_H, LTC2637_DAC_ALL}

Lookup table for DAC address.

Allows the "All DACs" address to be indexed right after DAC D in loops. This technique is very useful for devices with non-monotonic channel addresses. Map entered option 0..2 to DAC address

Definition at line 174 of file DC1534A.ino.

## ◆ demo_board_connected

uint8_t demo_board_connected
| static

Set to 1 if the board is connected.

Definition at line 160 of file DC1534A.ino.

## ◆ LTC2637_lsb

float LTC2637_lsb[9]
| static

The LTC2637 lsb - index 8 for "all DACs".

Definition at line 167 of file DC1534A.ino.

## ◆ LTC2637_offset

int16_t LTC2637_offset[9]
| static

DAC offset - index 8 for "all DACs".

Definition at line 166 of file DC1534A.ino.

## ◆ num_of_channels

uint8_t num_of_channels = 8
| static

Definition at line 168 of file DC1534A.ino.

## ◆ reference_mode

uint8_t reference_mode
| static

Tells whether to set internal or external reference.

Definition at line 162 of file DC1534A.ino.

## ◆ reference_voltage

float reference_voltage
| static

Reference voltage, either internal or external.

Definition at line 165 of file DC1534A.ino.

## ◆ shift_count

uint8_t shift_count
| static

The data align shift count.

For 16-bit=0, for 12-bits=4

Definition at line 161 of file DC1534A.ino.